
;DednDave Multiple Stationary Console Demo
;Version 1

;--------------------------------------------------------------------------

        INCLUDE \masm32\include\masm32rt.inc

;NOTE: This program does not use any crt or masm32 libraries/macros
;      The header could look like this:
;
;       .386
;       .MODEL  FLAT,STDCALL
;       OPTION  CASEMAP:NONE
;
;       INCLUDE    \masm32\include\windows.inc
;       INCLUDE    \masm32\include\kernel32.inc
;       INCLUDELIB \masm32\lib\kernel32.lib

;--------------------------------------------------------------------------

WrPos   PROTO   :DWORD,:DWORD,:DWORD
WrCon   PROTO   :DWORD,:DWORD
Dec16   PROTO   :DWORD

;--------------------------------------------------------------------------

        .CONST

Banner  db 'DednDave Multiple Stationary Console Demo'
        db 0
;end of Banner

CntrTtl db 13,10,13,10,' Counter: '
ScanTtl db 13,10,13,10,'ScanCode: '
MenuNew db 'Esc: Return'

        .DATA

;CState - used to govern the state machine
;
;CState is initially set to 0
;once a new console has been made, CState never gets back to 0
;
;   State 0 - original console, no new consoles have been made
;   State 1 - new console
;   State 2 - original console remake after new console
;   State 3 - exit program (CState never gets set to 3)
;
; Old State  Key  New State
;     0      Esc      3
;     0       N       1
;     1      Esc      2
;     1       N       1
;     2      Esc      3
;     2       N       1

CState  db 0
CntrCtl db 1
CntrVal dw 60000
MenuOrg db 'Esc: Exit'
MenuMsg db '  N: New Console  Any other key: ScanCode'
AscBuf  db 8 dup(32)

        .DATA?

EvntCnt dd ?

C0SAttr dd ?
C0CMode dd ?
C0CSiz  dd ?
C0CVis  dd ?
CntrPos dd ?
ScanPos dd ?
hStdOut dd ?
hStdInp dd ?
MenuPos dd ?

CursInfo   CONSOLE_CURSOR_INFO <>

BufInfo    CONSOLE_SCREEN_BUFFER_INFO <>
;  dwSize size of the console screen buffer in character columns and rows
;    x                 WORD
;    y                 WORD
;  dwCursorPosition
;    x                 WORD
;    y                 WORD
;  wAttributes         WORD
;  srWindow buffer coordinates of upper-left and lower-right corners of display window
;    Left              WORD
;    Top               WORD
;    Right             WORD
;    Bottom            WORD start
;  dwMaximumWindowSize max size of window in char columns/rows with current screen settings
;    x                 WORD
;    y                 WORD count

InpEvntRec INPUT_RECORD <>

AlgnBuf db 16 dup(?)

CntrSav dw ?
CntCSav db ?

        .CODE

;--------------------------------------------------------------------------

_main   PROC

;initialize the stationary display

CDemo0: call    SInit

;keyboard loop

CDemo1: dec byte ptr CntrCtl       ;counter updates once every second
        jnz     CDemo2

        mov byte ptr CntrCtl,20
        INVOKE  Dec16,
                dword ptr CntrVal
        inc     ecx
        INVOKE  WrPos,
                eax,
                ecx,
                CntrPos
        dec word ptr CntrVal

CDemo2: INVOKE  Sleep,
                50                 ;keyboard is polled 20 times per second
        call    InKyb              ;that is equiv to typing at 200 wpm
        jz      CDemo1

        cmp     al,49              ;"N" or "n" key ?
        jz      CDemo3

        dec     eax                ;"Esc" key ?
        jz      CDemo5

        inc     eax                ;neither - show the virtual scancode
        INVOKE  Dec16,
                eax
        inc     ecx
        inc     ecx
        INVOKE  WrPos,
                eax,
                ecx,
                ScanPos
        jmp     CDemo1

;"N" key - release the current console and create a new one

CDemo3: cmp byte ptr CState,1
        jz      CDemo4

        mov byte ptr CState,1
        mov     ax,CntrVal
        mov     CntrSav,ax
        mov     al,CntrCtl
        mov     CntCSav,al

CDemo4: mov word ptr CntrVal,60000
        mov byte ptr CntrCtl,1
        INVOKE  FreeConsole
        INVOKE  AllocConsole
        jmp     CDemo0

;"Esc" key - exit or return to original console

CDemo5: cmp byte ptr CState,1
        jnz     CDemo6

        mov byte ptr CState,2
        mov     ax,CntrSav
        mov     CntrVal,ax
        mov     al,CntCSav
        mov     CntrCtl,al
        INVOKE  FreeConsole
        INVOKE  AttachConsole,
                ATTACH_PARENT_PROCESS
        jmp     CDemo0

;restore original console screen settings

CDemo6: call    SExit

;terminate

        INVOKE  ExitProcess,
                0

_main   ENDP

;--------------------------------------------------------------------------

InKyb   PROC

;Poll keyboard

;  Returns: if no key: eax = 0
;                      ZF = set (zero)
;
;              if key: eax = virtual scan code
;                      ZF = clear (not zero)
;
InKyb0: push    eax
        INVOKE  PeekConsoleInput,
                hStdInp,
                ADDR InpEvntRec,
                1,
                esp
        pop     eax
        or      eax,eax
        jz      InKyb1             ;ZF set if no key

        INVOKE  ReadConsoleInput,
                hStdInp,
                ADDR InpEvntRec,
                1,
                ADDR EvntCnt
        dec word ptr InpEvntRec.EventType
        jnz     InKyb0             ;non-keyboard event type - check again

        dec dword ptr InpEvntRec.KeyEvent.bKeyDown
        jnz     InKyb0             ;keypress only

        xor     eax,eax
        inc     eax                ;ZF cleared if key
        movzx   eax,word ptr InpEvntRec.KeyEvent.wVirtualScanCode

InKyb1: ret

InKyb   ENDP

;--------------------------------------------------------------------------

        OPTION  PROLOGUE:NONE
        OPTION  EPILOGUE:NONE

WrPos   PROC    lpConBuffer:DWORD,nNumberOfBytes2Write:DWORD,dwConPos:DWORD

;Write to console at a specified cursor location

;Call With: lpConBuffer = ascii string address
;           nNumberOfBytes2Write = number of bytes to write
;           dwConPos = screen position
;           hStdOut = standard output handle
;           DF = 0 (up)

;  Returns: eax = number of bytes written
;           ebx, ebp, esi, edi, DF preserved

        push    ebp
        mov     ebp,esp
        INVOKE  SetConsoleCursorPosition,
                hStdOut,
                [ebp+16]
        xor     eax,eax
        mov     ecx,[ebp+12]
        jecxz   WrPos0

        push    eax
        mov     eax,esp
        INVOKE  WriteFile,
                hStdOut,
                [ebp+8],
                ecx,
                eax,
                NULL
        pop     eax

WrPos0: pop     ebp
        ret     12

WrPos   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------

        OPTION  PROLOGUE:NONE
        OPTION  EPILOGUE:NONE

WrCon   PROC    lpConBuffer:DWORD,nNumberOfBytes2Write:DWORD

;Write to console at the current cursor location

;Call With: lpConBuffer = ascii string address
;           nNumberOfBytes2Write = number of bytes to write
;           hStdOut = standard output handle
;           DF = 0 (up)

;  Returns: eax = number of bytes written
;           ebx, ebp, esi, edi, DF preserved

        push    ebp
        mov     ebp,esp
        xor     eax,eax
        mov     ecx,[ebp+12]
        jecxz   WrCon0

        push    eax
        mov     eax,esp
        INVOKE  WriteFile,
                hStdOut,
                [ebp+8],
                ecx,
                eax,
                NULL
        pop     eax

WrCon0: pop     ebp
        ret     8

WrCon   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------

        OPTION  PROLOGUE:NONE
        OPTION  EPILOGUE:NONE

Dec16   PROC    dwBin16InVal:DWORD

;Convert unsigned 16-bit binary to ASCII decimal string

;Call With: dwBin16InVal = word value to convert (dword framed)
;           AscBuf = 5 byte ascii buffer
;           DF = 0 (up)

;  Returns: eax = offset into AscBuf of first numchar
;                 leading zero supressed
;           ecx = ASCII byte count
;           ebx, ebp, esi, edi, DF preserved

        push    ebp
        mov     ebp,esp
        push    edi
        mov     ax,[ebp+8]
        mov     edi,offset AscBuf
        mov     cx,100
        xor     edx,edx
        div     cx
        xchg    eax,edx
        aam
        or      ax,3030h
        mov     [edi+4],al
        mov     [edi+3],ah
        xor     eax,eax
        xchg    eax,edx
        div     cx
        xchg    eax,edx
        aam
        or      ax,3030h
        mov     [edi+2],al
        mov     [edi+1],ah
        mov     al,30h
        or      dl,al
        mov     [edi],dl
        mov     ecx,4
        repz    scasb
        jz      Dec160

        dec     edi

Dec160: xchg    eax,edi
        pop     edi
        mov     ecx,offset AscBuf+5
        pop     ebp
        sub     ecx,eax
        ret     4

Dec16   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;--------------------------------------------------------------------------

SInit   PROC

;Initialize stationary display

;set console window title

        cmp byte ptr CState,1
        ja      SInit0

        INVOKE  SetConsoleTitle,
                ADDR Banner

;get/store the standard output handle

SInit0: INVOKE  GetStdHandle,
                STD_OUTPUT_HANDLE
        mov     hStdOut,eax

;realign the original console screen buffer

        cmp byte ptr CState,2
        jnz     SInit6

        INVOKE  GetConsoleScreenBufferInfo,
                hStdOut,
                ADDR BufInfo
        push    edi
        push    esi
        movzx   eax,word ptr BufInfo.srWindow.Bottom
        movzx   ecx,word ptr BufInfo.dwMaximumWindowSize.y
        cmp     eax,ecx
        jae     SInit1

        mov     ecx,eax
        inc     ecx

SInit1: shl     eax,16
        push    eax

SInit2: push    ecx
        push    eax
        push    ecx
        INVOKE  ReadConsoleOutputCharacter,
                hStdOut,
                ADDR AlgnBuf,
                8,
                eax,
                esp
        pop     ecx                   ;number of chars read
        cmp     cl,8
        jb      SInit3

        mov     edi,offset AlgnBuf+1
        cmp byte ptr [edi-1],68       ;is it "D" ?
        jnz     SInit3                ;no - next line

        mov     cl,7
        mov     esi,offset Banner+1
        repz    cmpsb                 ;test for "ednDave"
        jz      SInit4

SInit3: pop     eax
        sub     eax,10000h
        pop     ecx
        dec     ecx
        jnz     SInit2

        pop     eax
        sub     eax,60000h
        jmp short SInit5

SInit4: pop     eax
        pop     ecx
        pop     ecx

SInit5: pop     esi
        pop     edi
        shr     eax,16
        add     ax,2
        mov word ptr CntrPos+2,ax
        add     ax,2
        mov word ptr ScanPos+2,ax
        add     ax,2
        mov word ptr MenuPos+2,ax

;save initial cursor visibility value
;set cursor visibility to false (off)

SInit6: INVOKE  GetConsoleCursorInfo,
                hStdOut,
                ADDR CursInfo
        cmp byte ptr CState,0
        jnz     SInit7

        mov     eax,CursInfo.dwSize
        mov     C0CSiz,eax
        mov     eax,CursInfo.bVisible
        mov     C0CVis,eax

SInit7: mov dword ptr CursInfo.bVisible,FALSE
        INVOKE  SetConsoleCursorInfo,
                hStdOut,
                ADDR CursInfo

;save initial screen attribute

        cmp byte ptr CState,0
        jnz     SInit8

        INVOKE  GetConsoleScreenBufferInfo,
                hStdOut,
                ADDR BufInfo
        movzx   eax,BufInfo.wAttributes
        mov     C0SAttr,eax

;set text foreground to high intensity green

SInit8: INVOKE  SetConsoleTextAttribute,
                hStdOut,
                FOREGROUND_GREEN or FOREGROUND_INTENSITY

;display the banner

        cmp byte ptr CState,1
        ja      SInitA

        INVOKE  WrCon,
                ADDR Banner,
                SIZEOF Banner

;display the counter title

        INVOKE  WrCon,
                ADDR CntrTtl,
                SIZEOF CntrTtl

;set the counter position value

        INVOKE  GetConsoleScreenBufferInfo,
                hStdOut,
                ADDR BufInfo
        mov     eax,BufInfo.dwCursorPosition
        mov     CntrPos,eax

;display the scancode title

        INVOKE  WrCon,
                ADDR ScanTtl,
                SIZEOF ScanTtl

;set the scancode position value

        INVOKE  GetConsoleScreenBufferInfo,
                hStdOut,
                ADDR BufInfo
        mov     eax,BufInfo.dwCursorPosition
        mov     ScanPos,eax

;scroll to the menu position

        INVOKE  WrCon,
                ADDR ScanTtl,
                4

;set the menu position value

        INVOKE  GetConsoleScreenBufferInfo,
                hStdOut,
                ADDR BufInfo
        mov     eax,BufInfo.dwCursorPosition
        mov     MenuPos,eax

;display the "menu" message

        mov     edx,offset MenuNew
        mov     ecx,sizeof MenuNew
        cmp byte ptr CState,1
        jz      SInit9

        mov     edx,offset MenuOrg
        mov     ecx,sizeof MenuOrg

SInit9: INVOKE  WrPos,
                edx,
                ecx,
                eax
        INVOKE  WrCon,
                ADDR MenuMsg,
                SIZEOF MenuMsg

;get/store the standard input handle

SInitA: INVOKE  GetStdHandle,
                STD_INPUT_HANDLE
        mov     hStdInp,eax

;save the initial console mode

        cmp byte ptr CState,0
        jnz     SInitB

        INVOKE  GetConsoleMode,
                eax,
                ADDR C0CMode

;disable most input modes for this type of display

SInitB: INVOKE  SetConsoleMode,
                hStdInp,
                ENABLE_EXTENDED_FLAGS

;flush input buffer

        INVOKE  FlushConsoleInputBuffer,
                hStdInp
        ret

SInit   ENDP

;--------------------------------------------------------------------------

SExit   PROC

;Exit stationary display - restore initial screen settings

;restore screen attribute to initial setting

        INVOKE  SetConsoleTextAttribute,
                hStdOut,
                C0SAttr

;convert the "menu" string to spaces
;overwrite the "menu" message

        push    edi
        mov     edi,offset MenuOrg
        push    edi
        mov     ecx,sizeof MenuOrg+sizeof MenuMsg
        push    ecx
        mov     al,20h
        rep     stosb
        pop     ecx
        pop     edx
        pop     edi
        INVOKE  WrPos,
                edx,
                ecx,
                MenuPos

;position cursor for exit

        mov     eax,MenuPos
        sub     eax,10000h
        INVOKE  SetConsoleCursorPosition,
                hStdOut,
                eax

;restore initial console mode

        INVOKE  SetConsoleMode,
                hStdInp,
                C0CMode

;flush input buffer

        INVOKE  FlushConsoleInputBuffer,
                hStdInp

;set cursor visibility to initial setting

        INVOKE  SetConsoleCursorInfo,
                hStdOut,
                ADDR C0CSiz
        ret

SExit   ENDP

;--------------------------------------------------------------------------

        END     _main
